<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRow(); openModal(modal, 'Tipo de Venta')" class="btn btn-primary" [disabled]="loading">
      <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="dataGrid.data.length === 0 || loading">
      <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="main-card mb-3 card">
  <div class="card-body">

    <div *ngIf="!loading">

      <kendo-grid [data]="dataGrid" [filter]="filter" [filterable]="false" (filterChange)="filterChange($event)"
                  [selectable]="true" [navigable]="true" [reorderable]="true" [resizable]="true" [sort]="sort"
                  [sortable]="true"
                  (sortChange)="sortChange($event)" [groupable]="true" [group]="groups"
                  (groupChange)="groupChange($event)"
                  (edit)="editRow($event); openModal(modal, 'Tipo de Venta')" (remove)="deleteRow($event)"
                  style="height: 75vh">
          <ng-template kendoGridToolbarTemplate>
            <button type="button" kendoGridExcelCommand icon="file-excel" [disabled]="dataGrid.data.length === 0"
             class="btn-success">Exportar Excel</button>
          </ng-template>
        <kendo-grid-column field="tipo" title="Tipo" width="200"></kendo-grid-column>
        <kendo-grid-column field="tdesc" title="Descripción"></kendo-grid-column>
        <kendo-grid-column field="tclas" title="Clase" width="120" [filterable]="false"></kendo-grid-column>
        <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
          <ng-template kendoGridFilterCellTemplate>
            <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
            </kendo-switch>
          </ng-template>
          <ng-template kendoGridCellTemplate let-dataItem>
            <input type="checkbox" [checked]="dataItem.Inactivo" disabled/>
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-command-column title="Actions" width="190">
          <ng-template kendoGridCellTemplate let-isNew="isNew">
            <button kendoGridEditCommand [primary]="true">Editar</button>
            <button kendoGridRemoveCommand>Eliminar</button>
          </ng-template>
        </kendo-grid-command-column>
        <kendo-grid-excel fileName="{{this.heading}}.xlsx" [fetchData]="allData"></kendo-grid-excel>
      </kendo-grid>

    </div>
<app-loading *ngIf="loading"></app-loading>

  </div>
</div>


<ng-template #modal let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title" id="modal-graf">{{ modalTitle }}</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="row" *ngIf="flagShowForm">
      <form [formGroup]="myFormGroup" class="k-form">
        <div class="row-fluid">
            <legend *ngIf="!flagEdit">Nuevo Tipo de Venta</legend>
            <legend *ngIf="flagEdit">Actualizar Tipo de Venta</legend>
            <label class="k-form-field col-12">
              <span>Tipo</span>
              <input class="k-textbox" name="tipo" type="number" [(ngModel)]="myFormGroup.value.tipo"
                     formControlName="tipo" maxlength="2" pattern="[0-9]*"
                     [readOnly]="flagEdit">
            </label>
            <label class="k-form-field col-12">
              <span>Descripción</span>
              <input class="k-textbox" name="tdesc" [(ngModel)]="myFormGroup.value.tdesc"
                     formControlName="tdesc" maxlength="30">
            </label>
            <label class="k-form-field col-12">
              <span>Clasificación</span>
              <kendo-combobox [data]="dstiposventas" [textField]="'categoryName'"
                              [valueField]="'categoryId'"
                              [value]="'categoryName'" [(ngModel)]="myFormGroup.value.tclas"
                              [valuePrimitive]="true"
                              formControlName="tclas" name="tclas" class="w-100">
              </kendo-combobox>
            </label>
            <label class="k-form-field col-6">
              <span>Inactivo</span>
              <kendo-switch name="Inactivo" [(ngModel)]="myFormGroup.value.Inactivo"
                            formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </label>
        </div>
      </form>
    </div>
  </div>
  <div class="modal-footer">
      <button class="btn btn-success" (click)="guardarForm(); c();"
      [disabled]="myFormGroup.status === 'INVALID'">
        <i class="fas fa-save mr-2"></i>Guardar
      </button>
      <button class="btn btn-secondary" (click)="closeForm(); c('Close click')">Cerrar</button>
  </div>
</ng-template>

